﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
namespace MultiAutocompleteSQLC
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        //initialize all classes
        SqlConnection conn = new SqlConnection();
        SqlCommand cmd = new SqlCommand();
        SqlDataAdapter da = new SqlDataAdapter();
        DataTable dt = new DataTable();

        //declaring variables
        string query;
        int result;

        private void AutoSuggest()
        {
            try
            {

                //set a query for retrieving data in the database
                query = "Select * from tblplace";
                //initialize new Sql commands
                cmd = new SqlCommand();
                //hold the data to be executed.
                cmd.Connection = conn;
                cmd.CommandText = query;
                //initialize new Sql data adapter
                da = new SqlDataAdapter();
                //fetching query in the database.
                da.SelectCommand = cmd;
                //initialize new datatable
                dt = new DataTable();
                //refreshes the rows in specified range in the datasource. 
                da.Fill(dt);
               int max =  dt.Columns.Count;

               txtMultiSuggest.AutoCompleteCustomSource.Clear();
                foreach (DataRow r in dt.Rows)
                {
                    for (int i = 1; i < max; i++)
                    {
                 
                    //getting all rows in the specific field|Column
                    var rw = r.Field<string >(i);
                    //MessageBox.Show(rw);

                    //Set the properties of a textbox to make it auto suggest.
                    txtMultiSuggest.AutoCompleteMode = AutoCompleteMode.Suggest;
                    txtMultiSuggest.AutoCompleteSource = AutoCompleteSource.CustomSource;
                    //adding all rows into the textbox
                    txtMultiSuggest.AutoCompleteCustomSource.Add(rw);
                    }
                } 
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
             
            }

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //set a connection between SQL server and Visual C#
            conn.ConnectionString = "Data Source=.\\SQLEXPRESS;database=dbplace;trusted_connection=true;";
            AutoSuggest();
        }

        private void Button1_Click(object sender, EventArgs e)
        {
            try
            {
                //opening connection
                conn.Open();
                //create an insert query;
                query = "INSERT INTO tblplace (p_Country,p_City,p_ZipCode) VALUES('" + txtCountry.Text + "','" + txtCity.Text + "','" + txtZipCode.Text + "')";
                //it holds the data to be executed.
                cmd.Connection = conn;
                cmd.CommandText = query;
                //execute the data.
                result = cmd.ExecuteNonQuery();
                //validate the result of the executed query.
                if (result > 0)
                { 
                    MessageBox.Show("Data has been saved in the SQL database");
                    //calling a method
                    AutoSuggest();

                }
                else
                {
                    MessageBox.Show("SQL QUERY ERROR");
                }
                //closing connection
                conn.Close();

            }
            catch (Exception ex)//catch exeption
            {
                //displaying error message.
                MessageBox.Show(ex.Message);
            }
        }

        
    }
}
